use crate::{errors::RunError, stack::StackVec};

pub fn pick(memory: &mut StackVec, data: u16) {
    if data > memory.len() as u16 {
        eprintln!("{}", RunError::PickTooDeep);
        std::process::exit(2);
    }

    let arg = memory.pop();
    memory.push(*memory.get(memory.len() - (arg as usize) - 1).expect(&format!("{}", RunError::PickOutOfBounds)));
}